//altas y bajas

#include <stdio.h>
#include <graphics.h>

void introducir_clave();
void introducir_nick();
void sonido(int );

typedef struct
{
	char nick[16];
	char clave[11];
	char tipo;
	long puntos;
}t_usuario;

extern char nick[16];
extern char clave[11];
extern char clave2[11];


void altas()
{
	FILE *fichero;

	int x=0;
	t_usuario registro;


	if((fichero=fopen("jugadores.dat","a+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO");
		getch();
		exit(1);
	 }


	cleardevice();
	settextstyle(2,0,5);
	outtextxy(185,240,"Introduce los datos del nuevo usuario");
	sonido(1);
	sleep(2);
	introducir_nick();

	fread(&registro,sizeof(registro),1,fichero);
	while(!feof(fichero) && x!=1)
	  {
		  if(strcmp(registro.nick,nick)==0)
			{
				setcolor(13);
				cleardevice();
				settextstyle(2,0,5);
				outtextxy(185,240,"Este usuario ya est registrado");
				sonido(1);
				x=1;//nos sirve de comprobacion para ver si est o no
				sleep(2);
			}
		  fread(&registro,sizeof(registro),1,fichero);
	  }
	if(x==0)
		{
			introducir_clave();
			if(strcmp(clave,clave2)!=0) //por si hemos regresado de introducir_clave sin haber introducido las 2 iguales
			{
				fclose(fichero);
				return;
			}
			strcpy(registro.nick,nick);  //copiamos nombre y clave
			strcpy(registro.clave,clave);
			registro.tipo='N'; // novato
			registro.puntos=0;
			fwrite(&registro,sizeof(registro),1,fichero); //copiamos el usuario en fichero
			setcolor(13);
			cleardevice();
			settextstyle(2,0,5);
			outtextxy(185,240,"El usuario se ha creado con xito");
			sonido(1);
			sleep(2);
		}
	fclose(fichero);
}

void bajas()
{
	FILE *fichero;
	FILE *temporal;

	char filtro_nick[16];
	char filtro;
	t_usuario registro;

	if((fichero=fopen("jugadores.dat","a+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO");
		getch();
		exit(1);
	 }

	fread(&registro,sizeof(registro),1,fichero);
	if(!ferror(fichero) && !feof(fichero))
	{
		cleardevice();
		settextstyle(2,0,5);
		outtextxy(220,240,"Primero introduce tu nick");
		sonido(1);
		sleep(2);
		introducir_nick();

		while(!ferror(fichero) && !feof(fichero) && strcmp(nick,registro.nick)!=0)
		{
			fread(&registro,sizeof(registro),1,fichero);
		}
		if(strcmp(registro.nick,nick)==0)
		{
			setcolor(13);
			cleardevice();
			settextstyle(2,0,5);
			outtextxy(220,240,"Ahora introduce tu clave");
			sonido(1);
			sleep(2);
			introducir_clave();
			if(strcmp(registro.clave,clave)==0)
			{
				strcpy(filtro_nick,nick);//controlamos el nick de que quiere borrar
				filtro=registro.tipo;//controlamos el tipo del jugador para ver si puede o no borrar a los dems
				//ahora tenemos que volver a pedir el nick a borrar(solo el nick)
				// abrir el fichero y borrarlo

				setcolor(13);
				cleardevice();
				settextstyle(2,0,5);
				outtextxy(155,240,"Ahora introduce el nick del usuario a borrar");
				sonido(1);
				sleep(2);
				introducir_nick();// ahora introducimos usuario a borrar y comprobamos si est
				rewind(fichero);
				fread(&registro,sizeof(registro),1,fichero);
				while(!feof(fichero) && !ferror(fichero) && strcmp(registro.nick,nick)!=0)
				{
					fread(&registro,sizeof(registro),1,fichero);
				}
				//ahora si lo ha encontrado lo borraremos usando el fichero temporal
				//sino existe nos lo mostrar y saldremos cerrando los fichero
				if(strcmp(registro.nick,nick)==0)
				{

					//un superusuario no puede borrar a otro superusuario ni al maestro
					//un novato solo puede borrarse a s mismo
					//maestro borra a todos si quiere

					if(strcmp(filtro_nick,registro.nick)!=0 && filtro!='M')
					{
						setcolor(13);
						cleardevice();
						settextstyle(2,0,5);
						outtextxy(155,240,"No tiene privilegios para borrar a ese usuario");
						sonido(1);
						sleep(2);
						fclose(fichero);
						return;
					}


					rewind(fichero);

					if((temporal=fopen("temporal","a+b"))==NULL)
					{
						printf("\nNO SE PUEDE ABRIR EL FICHERO");
						getch();
						exit(1);
					}
					fread(&registro,sizeof(registro),1,fichero);
					while(!ferror(fichero) && !feof(fichero))
					{
						if(strcmp(registro.nick,nick)!=0)
						{
							fwrite(&registro,sizeof(registro),1,temporal);
						}
						fread(&registro,sizeof(registro),1,fichero);
					}
					fclose(fichero);
					fclose(temporal);
					remove("jugadores.dat");
					rename("temporal","jugadores.dat");
					setcolor(13);
					cleardevice();
					settextstyle(2,0,5);
					outtextxy(200,240,"Usuario borrado con xito");
					sonido(1);
					sleep(2);
					return;
				}
				else
				{
				cleardevice();
				setcolor(13);
				settextstyle(2,0,5);
				outtextxy(235,240,"Usuario no encontrado");
				sonido(1);
				sleep(2);
				fclose(fichero);
				return;
				}
			}
			else
			{
			fclose(fichero);//si no introduce bien los datos nos salimos del men bajas
			return;
			}
		}
		else
		{
			cleardevice();
			setcolor(13);
			settextstyle(2,0,5);
			outtextxy(235,240,"Usuario no encontrado");
			sonido(1);
			sleep(2);
			fclose(fichero);
			return;
		}
	}
	else
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(165,240,"Todava no hay usuarios registrados");
		sonido(1);
		sleep(2);
		fclose(fichero);
	}

}
