/* Proyecto Final MASTERMIND */
/* Creado por Andrs Prez Cutillas */
/* Ao 2003 Curso D.A.I. 1Y */


// Declaracin funciones


#include<graphics.h>
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>
#include<dos.h>
#include<string.h>
#include<ctype.h>
#include<time.h>

// Declaracin de estructuras


typedef struct      // Esta estructura nos servir para controlar el ratn
{
	int x;
	int y;
	int estado;
}t_raton;

typedef struct
{
	char nick[16];
	char clave[11];
	char tipo;
	long puntos;
}t_usuario;

typedef struct
{
	char colores;
	char pivotes;
	char intentos;
}t_configuracion;

typedef struct
{
	char nick[16];
	long puntos;
	char cadena_puntos[8];
	char estado[8]; //ganada o perdida
	char tipo[13];  //novato,superusuario,maestro
	char fecha[17];
}t_historial;


typedef struct
{
	int ganar;
	int col;
	int piv;
	int inte;
	int tiradas;
	int subtiradas;
	int maestra[6];
	int separacion_x;
	int separacion_y;
	int pila[15][6];
	char nick[16];
}t_sinfinal;



// Aqu estn todas las variables globales

int tarjeta=DETECT,modo=VGAHI,error;  // detectar tarjeta grfica
int est;  	      // La usaremos para asignarle el estado del ratn
t_raton raton;       // La usaremos para detectar la posicin del raton
char colores='6';
int  col;   // variable de colores pasada a tipo int
char pivotes='4';
int  piv;	  // variable de pivotes pasada a tipo int
char intentos='0';
int  inte;  // variable de intentos pasada a tipo int
extern char nick[16];
extern char clave[11];
extern char clave2[11]; //se usa porque la clave hay que ponerla 2 veces y comprobarla
int  jugada_maestra[6];//se usa para guardar la combinacin aleatoria de colores
int  separacion_x,separacion_y; // se usa para controlar la separacin entre crculos del juego
int tiradas,subtiradas,mates,jaques,ganar,salir;
int pila[15][6];
int suma_puntos; //variable que contendr ms adelante la frmula para sumar los puntos
t_sinfinal reg;//contendr los datos de la partida sin acabar para grabarlos
int jugada[6]; //aqu iremos guardando cada jugada para compararla con la jugada maestra

// Declaracion de funciones

void modo_grafico(void);
void presentacion(void);
void menu_principal(void);
void menu_puntuaciones(void);
void menu_estadisticas(void);
void estadisticas(void);
void menu_mantenimiento(void);
void mantenimiento(void);
void menu_configuracion(void);
void configuracion(void);
void jugar(void);
void pantalla_juego(void);
void ponraton(void);
void quitaraton(void);
void limi_mov(void);
t_raton posraton(void); // devuelve la posicin del ratn
void configurar_colores(void);
void configurar_pivotes(void);
void configurar_intentos(void);
void altas(void);
void bajas(void);
void modificaciones(void);
void consultas(void);
void historial(void);
void media(void);
void combinacion(void);
void introducir_nick(void);
void introducir_clave(void);
void cargar_configuracion(void);// para leer la configuracin guardada anteriormente
void grabar_configuracion(void);
void combinacion_aleatoria(void); //para coger aleatoriamente los colores de la jugada maestra
void circulos_juego(void); //nos dibuja los circulos de las jugadas en el juego
void rellenar_colores(void);// rellena los colores de muestra si hay ms de 6
void rellenar_jugada_maestra(void);
void sonido(int tipo);
int mostrar_puntuaciones(void);
void guardar_historial(t_usuario registro,int resultado); // recibir el resultado de la partida, tanto si ha sido ganada o perdida
int mirar_maestro(void); //controla si hay o no un jugador Maestro y devuelve la respuesta
void ponteclado(void);
void quitateclado(void);
void guardamedia(void);
int buscar_medias(void);
void cargar_partida(void);
void rellenar_media();

// Iniciamos el programa principal

void main()
{

	int salir=0;
	char a;

	//registramos los fichero obj que son las fuentes y el EGAVGA
	registerbgidriver(EGAVGA_driver);
	registerbgifont(triplex_font);
	registerbgifont(small_font);



	modo_grafico();
	presentacion();       // llamamos a la pantalla de presentacin
	cargar_configuracion(); // cargamos la configuracion si la hay
	while(kbhit()) //si se han pulsado teclas mientras la presentacin las anula
	{
	quitateclado();
	ponteclado();
	}
	menu_principal();       // llamamos al men principal
	limi_mov();



	while(salir==0)
	{

		ponraton();			// Mostramos el ratn
		raton=posraton();	// Asignamos a raton la posicin del ratn
		est=raton.estado;	// Asignamos a est el estado del ratn
		if((est & 0x01) == 1)  //leemos el estado del ratn
		{
			if(raton.x>=238 && raton.x<=315 && raton.y>=200 && raton.y<=212)
			{
				quitaraton();            // Quitamos el ratn
				mantenimiento();	// Llamamos al men de mantenimiento
				menu_principal();
			}

			else if(raton.x>238 && raton.x<=351 && raton.y >=220 && raton.y<=232)
			{
				quitaraton();
				configuracion();
				while(raton.estado!=0) raton=posraton();// esperamos a que el ratn est en _BX=0
				menu_principal();
			}

			 else if(raton.x>238 && raton.x<=345 && raton.y >=240 && raton.y<=252)
			{
				quitaraton();
				menu_puntuaciones();
				menu_principal();
			}

			else if(raton.x>238 && raton.x<=340 && raton.y >=260 && raton.y<=272)
			{
				quitaraton();
				estadisticas();
				menu_principal();
			}

			else if(raton.x>238 && raton.x<=292 && raton.y >=280 && raton.y<=292)
			{
				quitaraton();
				jugar();
				menu_principal();
			}

			else if(raton.x>238 && raton.x<=289 && raton.y >=320 && raton.y<=332)
			{
				quitaraton();
				salir=1;
			}

		}
		if(kbhit())  // Si se ha pulsado una tecla la capturo
		{
			a=getch();
			switch (a)
			{
				case '1':

					quitaraton();
					mantenimiento();
					menu_principal();
					break;

				case '2':

					quitaraton();
					configuracion();
					menu_principal();
					break;

				case '3':

					quitaraton();
					menu_puntuaciones();
					menu_principal();
					break;

				case '4':

					quitaraton();
					estadisticas();
					menu_principal();
					break;

				case '5':

					quitaraton();
					jugar();
					menu_principal();
					break;

				case '0':

					quitaraton();
					salir=1;
					break;

				default :

					break;
			}
		}
	}
	closegraph();
}



// Funciones

void modo_grafico()

{
	initgraph(&tarjeta,&modo,"");  //  iniciar modo grfico
	error=graphresult();
	if(error != grOk)  //  comprobar si hay error en modo grfico
	{
		printf("Error grfico; %s\n",grapherrormsg(error));
		getch();
		exit(1);
	}
}

void cargar_configuracion()
{
	FILE *fichero;
	t_configuracion registro;

	if((fichero=fopen("config.dat","r+b"))==NULL)
	 {
		//printf("\nNO SE PUEDE ABRIR EL FICHERO");
		//getch();
		return;
	 }
	fread(&registro,sizeof(registro),1,fichero);
	if(!ferror(fichero) && !feof(fichero))
	{
	colores=registro.colores;
	pivotes=registro.pivotes;
	intentos=registro.intentos;
	}
	fclose(fichero);
}
void grabar_configuracion()
{
	FILE *fichero;
	t_configuracion registro;

	if((fichero=fopen("config.dat","w+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO");
		getch();
		return;
	 }
	 registro.colores=colores;
	 registro.pivotes=pivotes;
	 registro.intentos=intentos;
	 fwrite(&registro,sizeof(registro),1,fichero);
	 fclose(fichero);
}
void ponteclado()
{
	_AH=0x0;
	geninterrupt(0x16);
}
void quitateclado()
{
	_AH=0x2;
	geninterrupt(0x16);
}
void ponraton()
{
	_AX=0x0001; // mostrar el cursor en pantalla
	geninterrupt(0x33);
}

void limi_mov()
{
	_AX=0x0007;  // limitar los movimientos horizontales
	_CX=0;
	_DX=638;
	geninterrupt(0x33);

	_AX=0x0008;  // limitar los movimientos verticales
	_CX=0;
	_DX=478;
	geninterrupt(0x33);
}

void quitaraton()
{
	_AX=0x0002;  // oculta el ratn de la pantalla
	geninterrupt(0x33);
}

t_raton posraton()
{
	t_raton raton;
	_AX=0x0003;  // obtener el estado del ratn
	geninterrupt(0x33);
	raton.estado=_BX;
	raton.x=_CX;
	raton.y=_DX;
	return raton;
}



void mantenimiento()
{

	int salir=0;
	char a;
	menu_mantenimiento();
	while(raton.estado!=0) raton=posraton();// esperamos a que el ratn est en _BX=0

	while(salir==0)
	{


		ponraton();        // Mostramos el ratn
		raton=posraton();	// Asignamos a raton la posicin del ratn
		est=raton.estado;	// Asignamos a est el estado del ratn

		if((est & 0x01) == 1)  //leemos el estado del ratn
		{
			if(raton.x>=239 && raton.x<=289 && raton.y>=203 && raton.y<=212)
			{
				quitaraton();            // Quitamos el ratn
				altas();
				menu_mantenimiento();
			}

			else if(raton.x>239 && raton.x<=293 && raton.y >=223 && raton.y<=232)
			{
				quitaraton();
				bajas();
				menu_mantenimiento();
			}

			else if(raton.x>238 && raton.x<=357 && raton.y >=241 && raton.y<=252)
			{
				quitaraton();
				modificaciones();
				menu_mantenimiento();
			}

			else if(raton.x>238 && raton.x<=321 && raton.y >=261 && raton.y<=272)
			{
				quitaraton();
				consultas();
				menu_mantenimiento();
			}

			else if(raton.x>238 && raton.x<=288 && raton.y >=301 && raton.y<=312)
			{
				quitaraton();
				salir=1;
			}

		}

		if(kbhit())  // Si se ha pulsado una tecla la capturo
		{
			a=getch();
			switch (a)
			{
				case '1':
					quitaraton();
					altas();
					menu_mantenimiento();
					break;
				case '2':
					quitaraton();
					bajas();
					menu_mantenimiento();
					break;
				case '3':
					quitaraton();
					modificaciones();
					menu_mantenimiento();
					break;
				case '4':
					quitaraton();
					consultas();
					menu_mantenimiento();
					break;
				case '0':
					quitaraton();
					salir=1;
					break;

				default :

					break;
			}
		}
	}
}



void modificaciones()
{
	FILE *fichero;
	FILE *fich;

	t_usuario registro;
	t_historial historial;

	long posicion;
	int ocupado,contador=0;
	char nick2[16];//es temporal,para diferenciar el nick, cuando buscamos si el nuevo nick est ocupado

	if((fichero=fopen("jugadores.dat","r+b"))==NULL)
	 {
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
		 return;
	 }

	fread(&registro,sizeof(registro),1,fichero);
	if(!ferror(fichero) && !feof(fichero))
	{
		setcolor(13);
		cleardevice();
		settextstyle(2,0,5);
		outtextxy(210,240,"Primero introduce tu nick");
		sonido(1);
		sleep(2);
		introducir_nick();

		while(!ferror(fichero) && !feof(fichero) && strcmp(nick,registro.nick)!=0)
		{
			fread(&registro,sizeof(registro),1,fichero);
		}
		if(strcmp(registro.nick,nick)==0)
		{
			strcpy(nick2,nick);
			setcolor(13);
			cleardevice();
			settextstyle(2,0,5);
			outtextxy(220,240,"Ahora introduce tu clave");
			sonido(1);
			sleep(2);
			introducir_clave();
			if(strcmp(registro.clave,clave)==0)
			{
				//ahora mostrar que ya puedes modificar tanto el nick como la clave
				setcolor(13);
				cleardevice();
				settextstyle(2,0,5);
				outtextxy(167,240,"Puedes modificar tanto tu nick, como tu clave");
				sonido(1);
				sleep(2);

				//antes que nada medir la posicion del nick, para despues colocarnos y machacarlo con el nuevo registro
				posicion=(long)ftell(fichero)-sizeof(registro);//nos guarda la posicin justo antes de el nick, para despues macharlo

				//aqu programaremos la modificacion y despues saldremos
				//pedir nuevo nick y buscar que no est ocupado
				//si est ocupado volver a pedir hasta 3 veces

				do
				{
					rewind(fichero);//rebobinamos el fichero
					ocupado=0;
					introducir_nick();//pedimos nick nuevo y buscamos que no este ocupado
					do
					{
						fread(&registro,sizeof(registro),1,fichero);
						if(strcmp(registro.nick,nick)==0 && strcmp(nick,nick2)!=0)//si est ocupado..
						{
							cleardevice();
							setcolor(13);
							cleardevice();
							settextstyle(2,0,5);
							outtextxy(275,240,"Nick ocupado");
							sonido(1);
							sleep(2);

						}
					}
					while(ocupado!=1 && !ferror(fichero) && !feof(fichero));
					contador++;
				}
				while(ocupado!=0 && contador<3); //mientras est ocupado el nick y sea los intentos menos de 3
				if(contador==3) return; //si hemos intentado 3 veces con un nick ocupado salimos de la funcion
				//si no est ocupado, pedir la contrasea
				if(ocupado==0)
				{
					introducir_clave();
					rewind(fichero);
					fseek(fichero,posicion,SEEK_SET); //si todo est bien, rebobinar y situarnos en posicion para leer otra vez el registro
					fread(&registro,sizeof(registro),1,fichero);
					fflush(stdin);
					strcpy(registro.nick,nick); // copiamos el nuevo nick y la nueva clave
					strcpy(registro.clave,clave);
					rewind(fichero);//nos situamos otra vez para machacar
					fseek(fichero,posicion,SEEK_SET);
					fwrite(&registro,sizeof(registro),1,fichero); //escribir registro que tenga nick y clave nueva, lo dems igual
					setcolor(13);
					cleardevice();
					settextstyle(2,0,5);
					outtextxy(185,240,"El usuario se ha modificado con xito");
					sonido(1);
					sleep(2);
					fclose(fichero);
					//ahora cambiamos el nick antiguo por el nuevo en los registros de historial.dat
					if((fich=fopen("historial.dat","r+b"))==NULL)
					{
						return;
					}
					else
					{
						 fflush(stdin);
						 fread(&historial,sizeof(historial),1,fich);
						 while(!ferror(fich) && !feof(fich))
						 {
							//printf("%s de histo y %s de nick2",historial.nick,nick2);getch();
							if(strcmp(historial.nick,nick2)==0)
							{
								strcpy(historial.nick,nick);
								posicion=(long)ftell(fich)-sizeof(historial);
								fseek(fich,posicion,SEEK_SET);
								fflush(stdin);
								fwrite(&historial,sizeof(historial),1,fich);
								rewind(fich);
							}
							fflush(stdin);
							fread(&historial,sizeof(historial),1,fich);
						 }
						 fclose(fich);
					}
					return;
				}


			}
			 else
			{
				//mostrar que la clave no es valida y salir
				setcolor(13);
				cleardevice();
				settextstyle(2,0,5);
				outtextxy(255,240,"Clave no vlida");
				sonido(1);
				sleep(2);
				fclose(fichero);
				return;
			}
		}
		else
		{
			//si no se ha encontrado el nick avisar y salir
			cleardevice();
			setcolor(13);
			settextstyle(2,0,5);
			outtextxy(225,240,"Usuario no encontrado");
			sonido(1);
			sleep(2);
			fclose(fichero);
			return;
		}
	}
	else
	{
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
		 return;
	}

}

void consultas()
{
	FILE *fichero;

	t_usuario registro;
	char tipo[13];
	char puntos[8];  //aqu convertiremos los puntos del registro en cadena de texto
	int x;

	if((fichero=fopen("jugadores.dat","a+b"))==NULL)
	 {
		printf("\nNO SE PUEDE ABRIR EL FICHERO");
		getch();
		exit(1);
	 }




	fread(&registro,sizeof(registro),1,fichero);
	if(!ferror(fichero) && !feof(fichero))
	{
		cleardevice();
		settextstyle(2,0,5);
		outtextxy(165,240,"Introduce el nick del usuario a consultar");
		sonido(1);
		sleep(2);
		introducir_nick();

		while(!ferror(fichero) && !feof(fichero) && strcmp(nick,registro.nick)!=0)
		{
			fread(&registro,sizeof(registro),1,fichero);
		}

		if(strcmp(nick,registro.nick)==0)
		{
			// convertimos las variables a cadenas para poder mostrarlas en modo grfico

			if(registro.tipo=='N') strcpy(tipo,"Novato\0");
			if(registro.tipo=='S') strcpy(tipo,"Superjugador\0");
			if(registro.tipo=='M') strcpy(tipo,"Maestro\0");
			itoa(registro.puntos,puntos,10);

			// ya las hemos convertido a cadena

			cleardevice();
			setcolor(13);
			settextstyle(2,0,7); // Elegimos tipografia,horizontal,tamao
			outtextxy(218,150,"DATOS DE USUARIO");
			setcolor(14);
			line(201,173,418,173);
			settextstyle(2,0,5);
			setcolor(13);
			outtextxy(240,200,"NICK:");
			outtextxy(240,220,"TIPO:");
			outtextxy(240,240,"PUNTOS:");
			setcolor(14);
			outtextxy(310,200,registro.nick);
			outtextxy(310,220,tipo);
			outtextxy(310,240,puntos);
			setcolor(13);
			fclose(fichero);
			getch();

			//limpiamos la cadena tipo para la prxima vez

			for(x=0;x<=13;x++)  tipo[x]='\0';

		}
		else
		{
			cleardevice();
			setcolor(13);
			settextstyle(2,0,5);
			outtextxy(235,240,"Usuario no encontrado");
			sonido(1);
			sleep(2);
			fclose(fichero);
		}
	}
	else
	{
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
	}
}



void configuracion()
{
	int salir=0;
	char a;
	menu_configuracion();
	while(raton.estado!=0) raton=posraton();// esperamos a que el ratn est en _BX=0


	while(salir==0)
	{


		ponraton();        // Mostramos el ratn
		raton=posraton();	// Asignamos a raton la posicin del ratn
		est=raton.estado;	// Asignamos a est el estado del ratn

		if((est & 0x01) == 1)  //leemos el estado del ratn
		{
			if(raton.x>=239 && raton.x<=331 && raton.y>=202 && raton.y<=212)
			{
				quitaraton();            // Quitamos el ratn
				configurar_colores();
				menu_configuracion();
			}

			else if(raton.x>239 && raton.x<=329 && raton.y >=222 && raton.y<=232)
			{
				quitaraton();
				configurar_pivotes();
				menu_configuracion();
			}

			else if(raton.x>238 && raton.x<=335 && raton.y >=240 && raton.y<=252)
			{
				quitaraton();
				configurar_intentos();
				menu_configuracion();
			}

			else if(raton.x>238 && raton.x<=288 && raton.y >=280 && raton.y<=292)
			{
				quitaraton();
				salir=1;
			}

		}

		if(kbhit())  // Si se ha pulsado una tecla la capturo
		{
			a=getch();
			switch(a)
			{
				case '1':

					quitaraton();
					configurar_colores();
					menu_configuracion();
					break;

				case '2':

					quitaraton();
					configurar_pivotes();
					menu_configuracion();
					break;

				case '3':

					quitaraton();
					configurar_intentos();
					menu_configuracion();
					break;

				case '0':

					quitaraton();
					salir=1;

				default :

					break;
			}
		}
	}
}




void menu_puntuaciones()
{
	int salir=0;
	char a;


	cleardevice();
	if(mostrar_puntuaciones()==1) return;//si no hay nada que mostrar salimos
	setcolor(13);
	settextstyle(2,0,7); // Elegimos tipografia,horizontal,tamao
	outtextxy(230,50,"PUNTUACIONES");
	setcolor(14);
	line(226,73,371,73);
	line(50,120,580,120);
	line(50,380,580,380);
	settextstyle(2,0,5);
	setcolor(13);
	outtextxy(100,100,"NICK                    TIPO                    PUNTOS");
	outtextxy(270,400,"0 Salir");


	while(raton.estado!=0) raton=posraton();// esperamos a que el ratn est en _BX=0


	while(salir==0)
	{


		ponraton();        // Mostramos el ratn
		raton=posraton();	// Asignamos a raton la posicin del ratn
		est=raton.estado;	// Asignamos a est el estado del ratn

		if((est & 0x01) == 1)  //leemos el estado del ratn
		{
			if(raton.x>=269 && raton.x<=318 && raton.y>=403 && raton.y<=412)
			{
				quitaraton();            // Quitamos el ratn
				salir=1;
			}
		}

		if(kbhit())  // Si se ha pulsado una tecla la capturo
		{
			a=getch();
			if(a=='0')
			{
				quitaraton();
				salir=1;
			}
		}
	}

}




void estadisticas()
{
	int salir=0;
	char a;
	menu_estadisticas();
	while(raton.estado!=0) raton=posraton();// esperamos a que el ratn est en _BX=0


	while(salir==0)
	{


		ponraton();        // Mostramos el ratn
		raton=posraton();	// Asignamos a raton la posicin del ratn
		est=raton.estado;	// Asignamos a est el estado del ratn

		if((est & 0x01) == 1)  //leemos el estado del ratn
		{
			if(raton.x>=239 && raton.x<=316 && raton.y>=203 && raton.y<=212)
			{
				quitaraton();            // Quitamos el ratn
				historial();
				menu_estadisticas();
			}

			else if(raton.x>239 && raton.x<=291 && raton.y >=223 && raton.y<=232)
			{
				quitaraton();
				media();
				menu_estadisticas();
			}

			else if(raton.x>237 && raton.x<=337 && raton.y >=243 && raton.y<=252)
			{
				quitaraton();
				combinacion();
				menu_estadisticas();
			}

			else if(raton.x>238 && raton.x<=288 && raton.y >=283 && raton.y<=292)
			{
				quitaraton();
				while(raton.estado!=0) raton=posraton();// esperamos a que el ratn est en _BX=0
				salir=1;

			}

		}

		if(kbhit())  // Si se ha pulsado una tecla la capturo
		{
			a=getch();
			switch(a)
			{
				case '1':

					quitaraton();
					historial();
					menu_estadisticas();
					break;

				case '2':

					quitaraton();
					media();
					menu_estadisticas();
					break;

				case '3':

					quitaraton();
					combinacion();
					menu_estadisticas();
					break;

				case '0':

					quitaraton();
					salir=1;

				default :

					break;
			}
		}
	}
}












void jugar()
{
	FILE *fichero;

	int x,y,z,opcion=1,mitad=2;
	int maestro;

	char punt[6];
	long posicion;
	t_usuario registro;

	if((fichero=fopen("jugadores.dat","r+b"))==NULL)
	 {
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
		 return;
	 }

	fread(&registro,sizeof(registro),1,fichero);
	if(!ferror(fichero) && !feof(fichero))
	{
		setcolor(13);
		cleardevice();
		settextstyle(2,0,5);
		outtextxy(210,240,"Primero introduce tu nick");
		sonido(1);
		sleep(2);
		introducir_nick();

		while(!ferror(fichero) && !feof(fichero) && strcmp(nick,registro.nick)!=0)
		{
			fread(&registro,sizeof(registro),1,fichero);
		}
		if(strcmp(registro.nick,nick)==0)
		{
			setcolor(13);
			cleardevice();
			settextstyle(2,0,5);
			outtextxy(220,240,"Ahora introduce tu clave");
			sonido(1);
			sleep(2);
			introducir_clave();
			if(strcmp(registro.clave,clave)==0)
			{
				//antes que nada medir la posicion del nick, para despues colocarnos y machacarlo con el nuevo registro
				posicion=(long)ftell(fichero)-sizeof(registro);//nos guarda la posicin justo antes de el nick, para despues macharlo


				// Ahora entramos en el juego y a jugar !!
				do
				{

					//reseteamos la pila
					for (x=0;x<15;x++)
					{
						for(y=0;y<6;y++) pila[x][y]=0;
					}

					ganar=1;//las ponemos a 1 por si jugaramos ms de una partida seguida
					salir=1;
					tiradas=0;// las ponemos a 0 por lo mismo
					subtiradas=0;


					//miramos si tiene alguna/s partida/s a medias
					//mitad; 1 si hay media partida 0 sino la hay
					if (mitad==2) mitad=buscar_medias();

					if(mitad==1)
					{
						cargar_partida();
						ganar=reg.ganar;
						col=reg.col;
						piv=reg.piv;
						inte=reg.inte;
						tiradas=reg.tiradas;
						subtiradas=reg.subtiradas;
						jugada_maestra[0]=reg.maestra[0];
						jugada_maestra[1]=reg.maestra[1];
						jugada_maestra[2]=reg.maestra[2];
						jugada_maestra[3]=reg.maestra[3];
						jugada_maestra[4]=reg.maestra[4];
						jugada_maestra[5]=reg.maestra[5];
						separacion_x=reg.separacion_x;
						separacion_y=reg.separacion_y;
						salir=1;
					}
					else combinacion_aleatoria(); // cargamos la combinacin a adivinar en el juego


					pantalla_juego();
					setcolor(14);   //mostramos en pantalla los datos del jugador
					settextstyle(2,0,5);
					if(strlen(registro.nick)>10) outtextxy(33,60,registro.nick);
					else outtextxy(60,60,registro.nick);

					itoa(registro.puntos,punt,10);
					if(registro.puntos>=100)outtextxy(68,140,punt);
					else if(registro.puntos>=10) outtextxy(74,140,punt);
					else  outtextxy(79,140,punt);

					// rellenamos los colores si hay ms de 6
					rellenar_colores();

					//colocamos los circulos del juego
					circulos_juego();

					if (mitad==1)
					{
						rellenar_media();
						mitad=0;
					}

					// colocamos la combinacin secreta en la pantalla
					for(z=0;z<piv;z++)
					{
						settextstyle(2,0,6);
						setcolor(14);
						if(piv==4)
						{
							circle(524+z*24,60,9);
							setfillstyle(1,0);
							floodfill(525+z*24,62,14);
							outtextxy(521+z*24,50,"?");
						}
						else if(piv==5)
						{
							circle(512+z*24,60,9);
							setfillstyle(1,0);
							floodfill(513+z*24,62,14);
							outtextxy(509+z*24,50,"?");
						}
						else if(piv==6)
						{
							circle(499+z*24,60,9);
							setfillstyle(1,0);
							floodfill(500+z*24,62,14);
							outtextxy(496+z*24,50,"?");
						}
					}

					// Rutina de rellenado de circulos por tiradas

					//printf("%d %d %d %d %d %d %d es jugada",jugada[0],jugada[1],jugada[2],jugada[3],jugada[4],jugada[5]);getch();
					while(tiradas<inte && ganar!=0 && salir!=0)
					{
						while(subtiradas<piv && salir!=0)
						{
							setcolor(13);
							settextstyle(2,0,8);
							outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
							do
							{
								while(kbhit()) //si se han pulsado teclas antes de pedirlas las anula
								{
									quitateclado();
									ponteclado();
								}

								fflush(stdin);
								x=toupper(getch());

								switch(x)
								{
									case 'A':

										jugada[subtiradas]=1;
										pila[tiradas][subtiradas]=1;
										opcion=0;
										//rellenar circulo
										setfillstyle(1,14);
										floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
										setcolor(14);
										settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										break;

									case 'B':

										jugada[subtiradas]=2;
										pila[tiradas][subtiradas]=2;
										opcion=0;
										//rellenar circulo
										setfillstyle(1,15);
										floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
										setcolor(15);
										settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										break;

									case 'G':

										jugada[subtiradas]=3;
										pila[tiradas][subtiradas]=3;
										opcion=0;
										//rellenar circulo
										setfillstyle(1,8);
										floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
										setcolor(8);
										settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										break;

									case 'M':

										jugada[subtiradas]=4;
										pila[tiradas][subtiradas]=4;
										opcion=0;
										//rellenar circulo
										setfillstyle(1,6);
										floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
										setcolor(6);
										settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										break;

									case 'N':

										jugada[subtiradas]=5;
										pila[tiradas][subtiradas]=5;
										opcion=0;
										//rellenar circulo
										setfillstyle(1,0);
										floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
										setcolor(0);
										settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										break;

									case 'R':

										jugada[subtiradas]=6;
										pila[tiradas][subtiradas]=6;
										opcion=0;
										//rellenar circulo
										setfillstyle(1,4);
										floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
										setcolor(4);
										settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										break;

									case 'S':

										if(col>6)
										{
											jugada[subtiradas]=7;
											pila[tiradas][subtiradas]=7;
											opcion=0;
											//rellenar circulo
											setfillstyle(1,13);
											floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
											setcolor(13);
											settextstyle(2,0,8);
											outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										}
										break;

									case 'V':

										if(col>7)
										{
											jugada[subtiradas]=8;
											pila[tiradas][subtiradas]=8;
											opcion=0;
											//rellenar circulo
											setfillstyle(1,2);
											floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
											setcolor(2);
											settextstyle(2,0,8);
										outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										}
										else opcion=1;
										break;

									case 'Z':

										if(col>8)
										{
											jugada[subtiradas]=9;
											pila[tiradas][subtiradas]=9;
											opcion=0;
											//rellenar circulo
											setfillstyle(1,1);
											floodfill(200+subtiradas*separacion_x,462-tiradas*separacion_y,14);
											setcolor(1);
											settextstyle(2,0,8);
											outtextxy(193+subtiradas*separacion_x,446-tiradas*separacion_y,"?");
										}
										else opcion=1;
										break;

									case 27:

										//rutina de escape
										sonido(1);
										setviewport(11,371,149,459,1);//abrir ventana en modo grafico
										setcolor(13);
										settextstyle(2,0,4);
										outtextxy(6,35,"Desea abandonar [S/N]?");
										while(kbhit()) //si se han pulsado teclas antes de pedirlas las anula
										{
											quitateclado();
											ponteclado();
										}
										do
										{
											fflush(stdin);
											x=toupper(getch());
										}
										while(x!='S' && x!='N');
										if(x=='S')
										{
											fclose(fichero);
											clearviewport(); // borramos pantallita
											outtextxy(6,35,"Guardar partida [S/N]?");
											do
											{
												fflush(stdin);
												x=toupper(getch());
											}
											while(x!='S' && x!='N');

											if(x=='S')  guardamedia();

											clearviewport(); // borramos pantallita
											setviewport(0,0,639,479,1);
											return;//salimos del juego cerrando fichero
										}
										clearviewport();
										setviewport(0,0,639,479,1);
										break;

									default  :

										opcion=1;
								}
							}
							while(opcion!=0 && salir!=0);
							opcion=1;
							subtiradas++;
						}
						subtiradas=0;
						mates=0;
						jaques=0;
						//comparar jugada con jugada maestra
						//printf("%d %d %d %d %d %d  es jugada",jugada[0],jugada[1],jugada[2],jugada[3],jugada[4],jugada[5]);getch();
						for(z=0;z<piv;z++)
						{
							if(jugada_maestra[z]==jugada[z])
							{
								 jugada[z]=-1;
								 mates++;
							}
						}
						for(z=0;z<piv;z++)
						{
							if(jugada_maestra[z]==jugada[0] && jugada[z] != -1)
								 {
									jugada[0]=-2; // los jaques los ponemos a -2 para diferenciar de los mates acertados
									jaques++;     // y funcione la comparacin
								 }
								else if(jugada_maestra[z]==jugada[1] && jugada[z] != -1)
									 {
										jugada[1]=-2;
										jaques++;
									 }
									else if(jugada_maestra[z]==jugada[2] && jugada[z] != -1)
										 {
											jugada[2]=-2;
											jaques++;
										 }
										else if(jugada_maestra[z]==jugada[3] && jugada[z] != -1)
											 {
												jugada[3]=-2;
												jaques++;
											 }
											else if(jugada_maestra[z]==jugada[4] && jugada[z] != -1)
												 {
													jugada[4]=-2;
													jaques++;
												 }
												 else if(jugada_maestra[z]==jugada[5] && jugada[z] != -1)
													  {
														jugada[5]=-2;
														jaques++;
													  }

						}
						//printf("%d%d%d%d%d%d jugada_maestra",jugada_maestra[0],jugada_maestra[1],jugada_maestra[2],jugada_maestra[3],jugada_maestra[4],jugada_maestra[5]);
						for(z=0;z<mates;z++)   // rellenamos los mates de color rosa
						{
							setfillstyle(1,13);
							if(piv==4) floodfill(540+z*15,462-tiradas*separacion_y,14);
							else if(piv==5) floodfill(532+z*15,462-tiradas*separacion_y,14);
							else if(piv==6) floodfill(522+z*15,462-tiradas*separacion_y,14);
						}
						for(z=0;z<jaques;z++)   // rellenamos los jaques de color amarillo
						{
							setfillstyle(1,14);
							if(piv==4) floodfill(540+(z+mates)*15,462-tiradas*separacion_y,14);
							else if(piv==5) floodfill(532+(z+mates)*15,462-tiradas*separacion_y,14);
							else if(piv==6) floodfill(522+(z+mates)*15,462-tiradas*separacion_y,14);
						}

						if(mates==piv) ganar=0;//si estn todos acertados ganar=0
						if(mates==0 && jaques==0 && salir==1) //si no se ha acertado nada en una tirada,salir=1 para que no nos lo muestre cuando damos a escape
						{
							setviewport(11,371,149,459,1);//abrir ventana en modo grafico
							sonido(1);
							setcolor(13);
							settextstyle(2,0,4);
							outtextxy(10,35,"No acertaste ninguno");
							sleep(1);
							clearviewport();
							setviewport(0,0,639,479,1);
						}

						tiradas++;
					}


					rellenar_jugada_maestra(); // mostramos la jugada maestra

					if(ganar==0) //si ganar=0 guardar los datos que procedan
					{

						//sumamos puntos a la variable del registro del jugador que tenemos en memoria
						suma_puntos=100-(piv*inte)+col;
						registro.puntos=registro.puntos + suma_puntos;//-(piv*inte)-col;
						//ahora comprobamos si cambia de tipo a superusuario
						if(registro.puntos>=500) registro.tipo='S';


						if(registro.puntos>1000)//mandamos a ver si hay o no un jugador Maestro
						{
							maestro=mirar_maestro();
							if(maestro==0) registro.tipo='M';
						}


						//nos situamos en posicin para machacar y actualizar al usuario en el fichero
						rewind(fichero);//rebobinamos
						fseek(fichero,posicion,SEEK_SET);
						fflush(stdin);
						fwrite(&registro,sizeof(registro),1,fichero); //escribir registro que tenga nick y clave nueva, lo dems igual

						itoa(suma_puntos,punt,10);  //convertimos suma_puntos en cadena

						// aqui hay que llamar a la funcin aadir_historial() para aadir la partida
						guardar_historial(registro,ganar);//le pasamos ganar que ser 0 si es ganada 1 si es perdida

						sonido(4);
						setviewport(11,371,149,459,1);//abrir ventana en modo grafico
						setcolor(13);
						settextstyle(2,0,4);
						outtextxy(40,20,"Has ganado");
						outtextxy(10,40,"Puntos:");
						outtextxy(80,40,punt);
						outtextxy(10,60,"Quieres seguir [S/N]?");

						while(kbhit()) //si se han pulsado teclas antes de pedirlas las anula
						{
							quitateclado();
							ponteclado();
						}

						do
						{
							fflush(stdin);
							x=toupper(getch());
						}
						while(x!='S' && x!='N');
						if(x=='N')
						{
							salir=0;
							fclose(fichero);
						}
						clearviewport();
						setviewport(0,0,639,479,1);
					}
					//sino mostrar que has perdido
					else
					{
						suma_puntos=0;
						// aqui hay que llamar a la funcin aadir_historial() para aadir la partida
						guardar_historial(registro,ganar);//le pasamos ganar que ser 0 si es ganada 1 si es perdida

						sonido(2);
						setviewport(11,371,149,459,1);//abrir ventana en modo grafico
						setcolor(13);
						settextstyle(2,0,4);
						outtextxy(40,20,"Has perdido");
						outtextxy(10,50,"Quieres seguir [S/N]?");

						while(kbhit()) //si se han pulsado teclas antes de pedirlas las anula
						{
							quitateclado();
							ponteclado();
						}

						do
						{
							fflush(stdin);
							x=toupper(getch());
						}
						while(x!='S' && x!='N');
						if(x=='N')
						{
							salir=0;
							fclose(fichero);
						}
						clearviewport();
						setviewport(0,0,639,479,1);
					}

				}
				while(salir!=0);

			}
			 else
			{
				//mostrar que la clave no es valida y salir
				setcolor(13);
				cleardevice();
				settextstyle(2,0,5);
				outtextxy(255,240,"Clave no vlida");
				sonido(1);
				sleep(2);
				fclose(fichero);
				return;
			}
		}
		else
		{
			//si no se ha encontrado el nick avisar y salir
			cleardevice();
			setcolor(13);
			settextstyle(2,0,5);
			outtextxy(225,240,"Usuario no encontrado");
			sonido(1);
			sleep(2);
			fclose(fichero);
			return;
		}
	}
	else
	{
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
		 return;
	}

}



void rellenar_colores()
{
	// rellenamos los colores si hay ms de 6
				if(col==7)
				{
					setfillstyle(1,13);   // pintar el 7
					floodfill(32,332,14);
					setfillstyle(7,14);   // tachar el 8,
					floodfill(82,332,14);
					setfillstyle(7,14);   // tachar el 9
					floodfill(132,332,14);
				}

				else if(col==8)
					{
						setfillstyle(1,13);   //pintar el 7,8
						floodfill(32,332,14);
						setfillstyle(1,2);
						floodfill(82,332,14);
						setfillstyle(7,14);   // tachar el 9
						floodfill(132,332,14);
					}
					else if(col==9)
						{
							setfillstyle(1,13);   // pintar el 7,8,9
							floodfill(32,332,14);
							setfillstyle(1,2);
							floodfill(82,332,14);
							setfillstyle(1,1);
							floodfill(132,332,14);
						}
						else
						{
							setfillstyle(7,14);   // tachar el 7
							floodfill(32,332,14);
							setfillstyle(7,14);   // tachar el 8,
							floodfill(82,332,14);
							setfillstyle(7,14);   // tachar el 9
							floodfill(132,332,14);
						}
}



void configurar_colores()
{

	char cadena[2]; //para poder mostrar el n de colores por pantalla
	char borrar;  //filtro para borrar el n de intentos si queremos

	do
	{
		do
		{
			cleardevice();
			outtextxy(220,220,"Introducir de 6 a 9");
			outtextxy(220,260,"N de colores:    ");
			fflush(stdin);
			colores=getch();
			cadena[0]=colores;
			cadena[1]='\0';
			setcolor(14);
			outtextxy(340,260,cadena);
			setcolor(13);
			fflush(stdin);
			borrar=getch();
		}
		while(borrar=='\b');
	}
	while(colores!='6' && colores!='7' && colores!='8' && colores!='9');
	grabar_configuracion();

}


void configurar_pivotes()
{
	char cadena[2];
	char borrar;

	do
	{
		do
		{
			cleardevice();
			outtextxy(220,220,"Introducir de 4 a 6");
			outtextxy(220,260,"N de pivotes:    ");
			fflush(stdin);
			pivotes=getche();
			cadena[0]=pivotes;
			cadena[1]='\0';
			setcolor(14);
			outtextxy(340,260,cadena);
			setcolor(13);
			fflush(stdin);
			borrar=getch();
		}
		while(borrar=='\b');
	}
	while(pivotes!='4' && pivotes!='5' && pivotes!='6');
	grabar_configuracion();
}

void configurar_intentos()
{

	char cadena[2];
	char borrar;

	do
	{
		do
		{
			cleardevice();
			outtextxy(210,220,"Introducir de 10 a 15");
			outtextxy(210,260,"N de intentos:       ");
			setcolor(14);
			outtextxy(330,260,"1");
			fflush(stdin);
			intentos=getch();
			cadena[0]=intentos;
			cadena[1]='\0';
			outtextxy(338,260,cadena);
			setcolor(13);
			fflush(stdin);
			borrar=getch();
		}
		while(borrar=='\b');
	}
	while(intentos!='0' && intentos!='1' && intentos!='2' && intentos!='3' && intentos!='4' && intentos!='5');
	grabar_configuracion();

}


void historial()
{
	FILE *fichero;

	int salir=0,x=0;
	char a;
	t_historial registro;

	introducir_nick();//leemos el nick del cual queremos saber su historial

	if((fichero=fopen("historial.dat","rb"))==NULL)
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(165,240,"Todava no se ha creado el historial");
		sonido(1);
		sleep(2);
		fclose(fichero);
		return;
	}

	fread(&registro,sizeof(registro),1,fichero);
	while(!ferror(fichero) && !feof(fichero) && strcmp(nick,registro.nick)!=0)
		{
			fread(&registro,sizeof(registro),1,fichero);
		}

	if(strcmp(registro.nick,nick)==0)  //si encontramos el nick hacemos ...
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,7); // Elegimos tipografia,horizontal,tamao
		if(strlen(nick)>13)
		{
			outtextxy(155,50,"Historial de");  //si el nick es largo lo situamos
			outtextxy(303,50,nick);
		}
		else if(strlen(nick)>11)
			{
				outtextxy(170,50,"Historial de");  // si el nick es mediano lo situamos
				outtextxy(319,50,nick);
			}
			else if(strlen(nick)>9)
				{
					outtextxy(180,50,"Historial de");  // si el nick es corto lo situamos
					outtextxy(329,50,nick);
				}
				else if(strlen(nick)>7)
					{
					outtextxy(190,50,"Historial de");
					outtextxy(339,50,nick);
					}
					else if(strlen(nick)>5)
						{
							outtextxy(200,50,"Historial de");
							outtextxy(349,50,nick);
						}
						else if(strlen(nick)>3)
							{
								outtextxy(210,50,"Historial de");
								outtextxy(359,50,nick);
							}
							else
							{
								outtextxy(225,50,"Historial de");
								outtextxy(374,50,nick);
							}


		setcolor(14);
		line(153,73,480,73);
		line(50,120,580,120);
		line(50,380,580,380);
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(90,100,"FECHA            TIPO            PUNTOS           ESTADO");

		// ahora abrimos una ventana grfica para mostrar los historiales que estn en el registro del nick que queremos
		setviewport(70,140,560,360,1);

		while(!ferror(fichero) && !feof(fichero))
		{
			if(strcmp(registro.nick,nick)==0)
			{
				if(x>9)
				{
					setcolor(14);
					outtextxy(110,6+x*20,"PULSA CUALQUIER TECLA PARA SEGUIR");
					setcolor(13);
					getch();
					clearviewport();

					x=0;
				}
				outtextxy(0,0+x*20,registro.fecha);
				outtextxy(150,0+x*20,registro.tipo);
				outtextxy(290,0+x*20,registro.cadena_puntos);
				outtextxy(420,0+x*20,registro.estado);
				x++;
			}

			fread(&registro,sizeof(registro),1,fichero);
		}
		fclose(fichero);
		setviewport(0,0,639,479,1);//volvemos a pantalla grfica grande

		outtextxy(270,400,"0 Salir");


		while(salir==0)
		{


			ponraton();        // Mostramos el ratn
			raton=posraton();	// Asignamos a raton la posicin del ratn
			est=raton.estado;	// Asignamos a est el estado del ratn

			if((est & 0x01) == 1)  //leemos el estado del ratn
			{
				if(raton.x>=269 && raton.x<=318 && raton.y>=403 && raton.y<=412)
				{
					quitaraton();            // Quitamos el ratn
					salir=1;
				}
			}

			if(kbhit())  // Si se ha pulsado una tecla la capturo
			{
				a=getch();
				if(a=='0')
				{
					quitaraton();
					salir=1;
				}
			}
		}
	} //fin del if que nos comprueba si est el nick buscado
	else
	{
		//si no se ha encontrado el nick avisar y salir
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(225,240,"Usuario no encontrado");
		sonido(1);
		sleep(2);
		fclose(fichero);
		return;
	}


}





void media()
{
	FILE *fichero;

	long float x=0;
	int cont=1;
	char puntos[8];
	t_historial registro;

	if((fichero=fopen("historial.dat","rb"))==NULL)
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(165,240,"Todava no se ha creado el historial");
		sonido(1);
		sleep(2);
		fclose(fichero);
		return;
	}
	fread(&registro,sizeof(registro),1,fichero);
	if(!ferror(fichero) && !feof(fichero))
	{
		do
		{
			x=x+registro.puntos;
			fread(&registro,sizeof(registro),1,fichero);
			cont++;
		}
		while(!ferror(fichero) && !feof(fichero));
		x=x/cont;
		itoa(x,puntos,10);
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(250,200,"La media de puntos");
		outtextxy(305,220,"del");
		outtextxy(242,240,"total de partidas es:");
		setcolor(14);
		outtextxy(305,260,puntos);
		setcolor(13);
		sonido(1);
		getch();
		fclose(fichero);
		return;
	}
	else
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(165,240,"Todava no se ha creado el historial");
		sonido(1);
		sleep(2);
		fclose(fichero);
		return;
	}
}

void combinacion()
{
	FILE *fichero;

	long grandaria=sizeof(jugada_maestra);
	long x,tamano;
	int  color,y,suma=0,veces=0,aux[6],aux2[6],combi[6];
	char veces_cadena[6];

	if((fichero=fopen("combinaciones.dat","rb"))==NULL)
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(140,240,"Todava no hay combinaciones registradas");
		sonido(1);
		sleep(2);
		fclose(fichero);
		return;
	}


	fseek(fichero,0,SEEK_END); // controlamos el tamao del fichero
	tamano=ftell(fichero);
	rewind(fichero);

	for(x=0;x<tamano;x=x+grandaria)
	{
		suma=0;
		fread(aux,grandaria,1,fichero); // leemos la primera combinacin
		rewind(fichero);

		for(y=0;y<tamano/grandaria;y++)//sabiendo el tamao del fichero vamos comparando las combinaciones
		{
			fread(aux2,grandaria,1,fichero); // leemos la segunda combinacin
			if(aux[0]==aux2[0] && aux[1]==aux2[1] && aux[2]==aux2[2] && aux[3]==aux2[3] && aux[4]==aux2[4] && aux[5]==aux2[5])
			{
				suma++;
				//printf("%d\n",suma);
			}
		}

		if(suma>veces)
		{
			combi[0]=aux[0];
			combi[1]=aux[1];
			combi[2]=aux[2];
			combi[3]=aux[3];
			combi[4]=aux[4];
			combi[5]=aux[5];
			veces=suma-1;//se resta 1 para que solo cuente las veces repetidas
		}
	}

	if(veces>0)
	{
		itoa(veces,veces_cadena,10);
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(150,240,"Veces que se ha repetido esta combinacin: ");
		outtextxy(485,240,veces_cadena);

		x=0;
		while(combi[x]!=0 && x<6) //dibujamos los circulos de la combinacin
		{
			setcolor(14);
			circle(200+x*45,300,15);
			switch(combi[x])
			{
				case 1:	color=14;
						break;
				case 2:	color=15;
						break;
				case 3:	color=8;
						break;
				case 4:	color=6;
						break;
				case 5:	color=0;
						break;
				case 6:	color=4;
						break;
				case 7:	color=13;
						break;
				case 8:	color=2;
						break;
				case 9:	color=1;
						break;
			}
			setfillstyle(1,color);
			floodfill(202+x*45,302,14);//rellenamos los circulos
			x++;
		}
	}
	else
	{
		cleardevice();
		setcolor(13);
		settextstyle(2,0,5);
		outtextxy(185,240,"No hay combinaciones repetidas");
		sonido(1);
		sleep(2);
	}
	fclose(fichero);

}



void combinacion_aleatoria()
{
	FILE *fich;

	int x;

	for(x=0;x<6;x++)  jugada_maestra[x]=0;// ponemos a cero todas los elementos del array


	if((fich=fopen("combinaciones.dat","ab"))==NULL)
	 {
		 printf("error,no se puede abrir el fichero de combinaciones.dat");
		 getch();
		 exit(1);
	 }

	if(pivotes=='4') piv=4;      //pasamos de caracter a entero las variables colores y pivotes
	else if(pivotes=='5') piv=5;
	else if(pivotes=='6') piv=6;
	if(colores=='6') col=6;
	else if(colores=='7') col=7;
	else if(colores=='8') col=8;
	else if(colores=='9') col=9;

	randomize();

	for(x=0;x<piv;x++)
	{
		jugada_maestra[x]=random(col)+1;//as no coger el 0
		fflush(stdin);
	}
	fwrite(&jugada_maestra,sizeof(jugada_maestra),1,fich);//guardamos combinacin en fichero para cuando se pida la media
	fclose(fich);
}

void rellenar_jugada_maestra()
{

	int z,color;

	// colocamos la combinacin secreta en la pantalla
	for(z=0;z<piv;z++)
	{
		switch(jugada_maestra[z])
		{
			case 1:	color=14;
					break;
			case 2:	color=15;
					break;
			case 3:	color=8;
					break;
			case 4:	color=6;
					break;
			case 5:	color=0;
					break;
			case 6:	color=4;
					break;
			case 7:	color=13;
					break;
			case 8:	color=2;
					break;
			case 9:	color=1;
					break;
		}

		settextstyle(2,0,6);
		if(piv==4)
		{
			setcolor(color);
			setfillstyle(1,color);
			floodfill(526+z*24,62,14);
			outtextxy(521+z*24,50,"?");
		}
		else if(piv==5)
		{
			setcolor(color);
			setfillstyle(1,color);
			floodfill(511+z*24,62,14);
			outtextxy(509+z*24,50,"?");
		}
		else if(piv==6)
		{
			setcolor(color);
			setfillstyle(1,color);
			floodfill(501+z*24,62,14);
			outtextxy(496+z*24,50,"?");
		}
	}
}


void circulos_juego()
{
	int x,y,z,v,tamano_circulo;

	if(intentos=='0') inte=10;     // pasamos a entero la variable intentos
	else if(intentos=='1') inte=11;
	else if(intentos=='2') inte=12;
	else if(intentos=='3') inte=13;
	else if(intentos=='4') inte=14;
	else if(intentos=='5') inte=15;

	if(piv==4) separacion_x=81;    // calculamos la separacin entre crculo y crculo
	else if(piv==5) separacion_x=61;
	else if(piv==6) separacion_x=48;

	if(inte==10)
	{
		separacion_y=40;
		tamano_circulo=15;
	}
	else if(inte==11)
		{
			separacion_y=36;
			tamano_circulo=15;
		}
		else if(inte==12)
			{
				separacion_y=33;
				tamano_circulo=15;
			}
			else if(inte==13)
				{
					separacion_y=30;
					tamano_circulo=14;
				}
				else if(inte==14)
					{
						separacion_y=28;
						tamano_circulo=13;
					}
					else if(inte==15)
						{
						separacion_y=26;
						tamano_circulo=12;
						}

	for(y=0;y<inte;y++)    //dibujamos los circulos del juego (los de la pantalla)
	{

		for(x=0;x<piv;x++)
		{
			circle(198+x*separacion_x,460-y*separacion_y,tamano_circulo);
		}
	}
	for(v=0;v<inte;v++)     // dibujamos los circulos de aciertos (los pequeos)
	{
		for(z=0;z<piv;z++)
			{
				if(piv==4) circle(538+z*15,462-v*separacion_y,6);
				else if(piv==5) circle(530+z*15,462-v*separacion_y,6);
				else if(piv==6) circle(520+z*15,462-v*separacion_y,6);
			}
	}
}


void sonido(int tipo)
{
  int c;

  switch (tipo)
  {
	case 1:
	 sound(1000);
	 delay(50);
	 sound(3000);
	 delay(50);
	 sound(2000);
	 delay(50);
	 nosound();
	 break;
    case 2:
	 sound(200);
	 delay(400);
	 sound(190);
	 delay(400);
	 sound(180);
	 delay(400);
	 nosound();
	 break;
    case 3:
	 sound(300);
	 delay(300);
	 sound(350);
	 delay(300);
	 sound(400);
	 delay(300);
	 sound(400);
	 delay(200);
	 sound(350);
	 delay(150);
	 nosound();
	 break;
    case 4:
	 for(c=0;c<10;c++)
	 {
		sound(c<<c);
		delay(100);
		nosound();
	 }
	 break;

  }

}




int mostrar_puntuaciones()
{
	// Emparejar fichero por el campo PUNTOS

	FILE *fichero;
	FILE *temporal;

	t_usuario aux;
	t_usuario registro;
	int x=0;
	char puntos[8]; // para pasar a cadena los puntos y poder mostrarlos en modo grfico

	if((fichero=fopen("jugadores.dat","rb"))==NULL)
	 {
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
		 return(1);
	 }

	temporal=fopen("temporal","w+b");

	fflush(stdin);

	fread(&aux,sizeof(aux),1,fichero);

	if(!ferror(fichero) && !feof(fichero))
	{
		while(!ferror(fichero) && !feof(fichero))
		{
			fflush(stdin);
			fread(&registro,sizeof(aux),1,fichero);
			while(!ferror(fichero) && !feof(fichero))
			{
				if(aux.puntos >= registro.puntos)
				{
					fflush(stdin);
					fread(&registro,sizeof(registro),1,fichero);
				}
				else
				{
					strcpy(aux.nick,registro.nick);   //copiamos el nick
					strcpy(aux.clave,registro.clave); //copiamos la clave
					aux.tipo=registro.tipo;           //copiamos el tipo
					aux.puntos=registro.puntos;       //copiamos los puntos

					fflush(stdin);
					fread(&registro,sizeof(aux),1,fichero);
				}
			}
			fflush(stdin);
			fwrite(&aux,sizeof(aux),1,temporal);
			fflush(stdin);
			rewind(fichero);//rebobinamos el fichero y nos situamos una posicin adelante de la que hemos leido antes con aux
			x++;
			fseek(fichero,sizeof(registro)*x,SEEK_SET);
			fread(&aux,sizeof(aux),1,fichero);
		}

		fclose(fichero);
		fclose(temporal);
		remove("jugadores.dat");
		rename("temporal","jugadores.dat");

		// hasta aqu hemos emparejado el fichero por el campo PUNTOS
		// ahora vamos a mostrar en pantalla la lista

		x=0;

		fichero=fopen("jugadores.dat","rb");

		fread(&registro,sizeof(aux),1,fichero);
		while(!ferror(fichero) && !feof(fichero) && x<10 && registro.puntos > 0)
		{
			setcolor(13);
			settextstyle(2,0,5);
			outtextxy(80,146+x*21,registro.nick);
			if(registro.tipo=='N') outtextxy(280,146+x*21,"Novato");
			else if(registro.tipo=='S') outtextxy(280,146+x*21,"SuperUsuario");
			else if(registro.tipo=='M') outtextxy(260,146+x*21,"Maestro");
			itoa(registro.puntos,puntos,10);//pasamos a cadena los puntos
			outtextxy(490,146+x*21,puntos);



			x++;
			fflush(stdin);
			fread(&registro,sizeof(aux),1,fichero);

		}
		fclose(fichero);
		return(0);
	}
	else
	{
		 cleardevice();
		 setcolor(13);
		 settextstyle(2,0,5);
		 outtextxy(165,240,"Todava no hay usuarios registrados");
		 sonido(1);
		 sleep(2);
		 fclose(fichero);
		 return(1);
	}
}

void  guardar_historial( t_usuario registro,int resultado)
{
	FILE *fichero;

	time_t tiempo;
	t_historial historial;

	char puntos[8];
	char cad [17];
	struct tm *tmPtr;

	// con esto guardamos la fecha y la hora en cad
	tiempo=time(NULL);
	tmPtr=localtime(&tiempo);
	strftime(cad,17,"%H:%M/%d/%m/%y",tmPtr);
	//*********************************************
	fichero=fopen("historial.dat","ab");

	//copiamos el nick
	strcpy(historial.nick,registro.nick);
	//copiamos los puntos ganados en la partida(modo char para mostrar) a la estructura historial
	itoa(suma_puntos,puntos,10);
	strcpy(historial.cadena_puntos,puntos);
	//copiamos los puntos ganados en la partida(modo long para despus hacer la media) a la estructura historial
	historial.puntos=registro.puntos;
	//copimos el tipo
	if(registro.tipo=='N')      strcpy(historial.tipo,"Novato\0");
	else if(registro.tipo=='S') strcpy(historial.tipo,"SuperUsuario\0");
	else if(registro.tipo=='M') strcpy(historial.tipo,"Maestro\0");
	//copiamos el estado
	if(resultado==0)      strcpy(historial.estado,"Ganada");
	else if(resultado==1) strcpy(historial.estado,"Perdida");
	//copiamos la fecha
	strcpy(historial.fecha,cad);
	fwrite(&historial,sizeof(historial),1,fichero);
	fclose(fichero);
}

int mirar_maestro()
{
	FILE *fich;

	t_usuario registro;
	int x=0;

	fich=fopen("jugadores.dat","rb");

	fread(&registro,sizeof(registro),1,fich);
	while(!ferror(fich) && !feof(fich))
	{
		if(registro.tipo=='M') x=1;
		fread(&registro,sizeof(registro),1,fich);
	}

	fclose(fich);
	return(x);
}

void guardamedia()
{
	FILE *fiche;
	FILE *temp;

	t_sinfinal reg;
	int x,y;

	reg.ganar=ganar;
	reg.col=col;
	reg.piv=piv;
	reg.inte=inte;
	reg.tiradas=tiradas;
	reg.subtiradas=subtiradas;
	reg.maestra[0]=jugada_maestra[0];
	reg.maestra[1]=jugada_maestra[1];
	reg.maestra[2]=jugada_maestra[2];
	reg.maestra[3]=jugada_maestra[3];
	reg.maestra[4]=jugada_maestra[4];
	reg.maestra[5]=jugada_maestra[5];
	reg.separacion_x=separacion_x;
	reg.separacion_y=separacion_y;

	for(x=0;x<15;x++)
	{
		for(y=0;y<6;y++)
		{
			reg.pila[x][y]=pila[x][y];
			//printf("%d",reg.pila[x][y]);
		}
	}
	strcpy(reg.nick,nick);

	fiche=fopen("medias.dat","a+b");
	fflush(stdin);
	fwrite(&reg,sizeof(reg),1,fiche);
	fclose(fiche);
}

int buscar_medias()
{
	FILE *fich;

	int x=0,opc;
	t_sinfinal reg;

	if((fich=fopen("medias.dat","rb"))==NULL)
	{
	return(0);
	}

	fread(&reg,sizeof(reg),1,fich);
	while(!ferror(fich) && !feof(fich))
	{
		// cuando encuentre el nick nos situar al final del fichero
		if(strcmp(reg.nick,nick)==0)
		{
			fseek(fich,0,SEEK_END);
			cleardevice();
			setcolor(13);
			settextstyle(2,0,4);
			outtextxy(190,220,"Tienes por lo menos 1 partida sin terminar");
			outtextxy(230,242,"Deseas acabarla [S/N]?");
			do
			{
				fflush(stdin);
				opc=toupper(getch());
			}
			while(opc!='S' && opc!='N');
			if(opc=='S')
			{
			x=1;//ahora usamos mitad para saber si la seguimos
			    //o empezamos una nueva
			}
		}
		fread(&reg,sizeof(reg),1,fich);
	}
	fclose(fich);
	return(x);
}

void cargar_partida()
{
	FILE *fich;
	FILE *temp;

	int z,borrado=0;
	int jugada[6];
	t_sinfinal registro;

	fich=fopen("medias.dat","rb");
	//luego pondremos la forma de abrirlo bien

	//damos por sabido que seguro que hay un registro
	//con el nick que buscamos
	//porque previamente lo buscamos
	fread(&reg,sizeof(reg),1,fich);
	while(!ferror(fich) && !feof(fich))
	{
		// cuando encuentre el nick nos situar al final del fichero
		if(strcmp(reg.nick,nick)==0) fseek(fich,0,SEEK_END);
		fread(&reg,sizeof(reg),1,fich);
	}
	rewind(fich);
	//ahora borramos el registro del fichero, puesto que ya est cargado en juego
	temp=fopen("temp","a+b");
	fread(&registro,sizeof(registro),1,fich);
	while(!ferror(fich) && !feof(fich))
	{
		if(strcmp(registro.nick,nick)!=0) fwrite(&registro,sizeof(registro),1,temp);
		else if(borrado==1)  fwrite(&registro,sizeof(registro),1,temp);
			else borrado=1;
		fread(&registro,sizeof(registro),1,fich);
	}
	fclose(fich);
	fclose(temp);
	remove("medias.dat");
	rename("temp","medias.dat");
	return;
}

void rellenar_media()
{
	int x=0,y=0,z,sinacabar=0;

	while(x<inte && reg.pila[x][0]!=0)
	{
		y=0;
		while(y<piv&& reg.pila[x][0]!=0 )
		{

			//printf("pila[%d][%d]es %d ",x,y,reg.pila[x][y]);getch();
			switch(reg.pila[x][y])
			{

				case 0:
					//que no haga nada,sabemos que se ha quedado
					//a medias en subtiradas
					sinacabar=1;
					jugada[y]=0;
					pila[x][y]=0;

					break;

				case 1:
					//rellenar circulo
					pila[x][y]=1;
					jugada[y]=1;
					setfillstyle(1,14);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(14);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 2:
					//rellenar circulo
					pila[x][y]=2;
					jugada[y]=2;
					setfillstyle(1,15);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(15);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 3:
					//rellenar circulo
					pila[x][y]=3;
					jugada[y]=3;
					setfillstyle(1,8);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(8);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 4:
					//rellenar circulo
					pila[x][y]=4;
					jugada[y]=4;
					setfillstyle(1,6);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(6);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 5:
					//rellenar circulo
					pila[x][y]=5;
					jugada[y]=5;
					setfillstyle(1,0);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(0);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 6:
					//rellenar circulo
					pila[x][y]=6;
					jugada[y]=6;
					setfillstyle(1,4);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(4);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 7:
					//rellenar circulo
					pila[x][y]=7;
					jugada[y]=7;
					setfillstyle(1,13);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(13);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 8:

					//rellenar circulo
					pila[x][y]=8;
					jugada[y]=8;
					setfillstyle(1,2);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(2);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

				case 9:
					//rellenar circulo
					pila[x][y]=9;
					jugada[y]=9;
					setfillstyle(1,1);
					floodfill(200+y*separacion_x,462-x*separacion_y,14);
					setcolor(1);
					settextstyle(2,0,8);
					outtextxy(193+y*separacion_x,446-x*separacion_y,"?");
					break;

			}
			y++;

		}
		//comparar jugada con jugada maestra
		if(sinacabar==0)
		{

			jaques=0;
			mates=0;
			for(z=0;z<piv;z++)
			{
				if(jugada_maestra[z]==jugada[z])
				{
					jugada[z]=-1;
					mates++;
				}
			}
			for(z=0;z<piv;z++)
			{
				if(jugada_maestra[z]==jugada[0] && jugada[z] != -1)
				{
					jugada[0]=-2; // los jaques los ponemos a -2 para diferenciar de los mates acertados
					jaques++;     // y funcione la comparacin
					}
					else if(jugada_maestra[z]==jugada[1] && jugada[z] != -1)
						{
							jugada[1]=-2;
							jaques++;
						}
						else if(jugada_maestra[z]==jugada[2] && jugada[z] != -1)
							{
								jugada[2]=-2;
								jaques++;
							}
							else if(jugada_maestra[z]==jugada[3] && jugada[z] != -1)
								{
									jugada[3]=-2;
									jaques++;
								}
								else if(jugada_maestra[z]==jugada[4] && jugada[z] != -1)
									{
										jugada[4]=-2;
										jaques++;
									}
									else if(jugada_maestra[z]==jugada[5] && jugada[z] != -1)
										{
											jugada[5]=-2;
											jaques++;
										}
			}

			for(z=0;z<mates;z++)   // rellenamos los mates de color rosa
			{
				setfillstyle(1,13);
				if(piv==4) floodfill(540+z*15,462-x*separacion_y,14);
				else if(piv==5) floodfill(532+z*15,462-x*separacion_y,14);
					else if(piv==6) floodfill(522+z*15,462-x*separacion_y,14);
			}
			for(z=0;z<jaques;z++)   // rellenamos los jaques de color amarillo
			{
				setfillstyle(1,14);
				if(piv==4) floodfill(540+(z+mates)*15,462-x*separacion_y,14);
				else if(piv==5) floodfill(532+(z+mates)*15,462-x*separacion_y,14);
					else if(piv==6) floodfill(522+(z+mates)*15,462-x*separacion_y,14);
			}
		}

	x++;
	}
}